Index: issm/trunk/src/m/classes/matice.m
===================================================================
--- issm/trunk/src/m/classes/matice.m	(revision 25994)
+++ issm/trunk/src/m/classes/matice.m	(revision 26744)
@@ -6,29 +6,23 @@
 classdef matice
 	properties (SetAccess=public) 
-		rho_ice                    = 0.;
-		rho_water                  = 0.;
-		rho_freshwater             = 0.;
-		mu_water                   = 0.;
-		heatcapacity               = 0.;
-		latentheat                 = 0.;
-		thermalconductivity        = 0.;
-		temperateiceconductivity   = 0.;
+		rho_ice                         = 0.;
+		rho_water                       = 0.;
+		rho_freshwater                  = 0.;
+		mu_water                        = 0.;
+		heatcapacity                    = 0.;
+		latentheat                      = 0.;
+		thermalconductivity             = 0.;
+		temperateiceconductivity        = 0.;
 		effectiveconductivity_averaging = 0.;
-		meltingpoint               = 0.;
-		beta                       = 0.;
-		mixed_layer_capacity       = 0.;
-		thermal_exchange_velocity  = 0.;
-		rheology_B   = NaN;
-		rheology_n   = NaN;
-		rheology_law = '';
+		meltingpoint                    = 0.;
+		beta                            = 0.;
+		mixed_layer_capacity            = 0.;
+		thermal_exchange_velocity       = 0.;
+		rheology_B                      = NaN;
+		rheology_n                      = NaN;
+		rheology_law                    = '';
 
-		%giaivins: 
-		lithosphere_shear_modulus  = 0.;
-		lithosphere_density        = 0.;
-		mantle_shear_modulus       = 0.;
-		mantle_density             = 0.;
-
-		%slr
-		earth_density              = 0;
+		%slc
+		earth_density                   = 0;
 
 	end
@@ -81,5 +75,5 @@
 			%wet ice thermal conductivity (W/m/K)
 			self.temperateiceconductivity=.24;
-			
+
 			%computation of effective conductivity
 			self.effectiveconductivity_averaging=1;
@@ -101,9 +95,7 @@
 			self.rheology_law='Paterson';
 
-			% GIA:
-			self.lithosphere_shear_modulus  = 6.7*10^10;  % (Pa)
-			self.lithosphere_density        = 3.32;       % (g/cm^-3)
-			self.mantle_shear_modulus       = 1.45*10^11; % (Pa)
-			self.mantle_density             = 3.34;       % (g/cm^-3)
+			%Rheology for ice: 
+			self.rheology_B=2.1*1e8;
+			self.rheology_n=3;
 
 			%SLR
@@ -112,6 +104,8 @@
 		end % }}}
 		function md = checkconsistency(self,md,solution,analyses) % {{{
-	
-			if ~strcmpi(solution,'SealevelriseSolution'),
+
+			if strcmpi(solution,'TransientSolution') & md.transient.isslc,
+				md = checkfield(md,'fieldname','materials.earth_density','>',0,'numel',1);
+			else
 				md = checkfield(md,'fieldname','materials.rho_ice','>',0);
 				md = checkfield(md,'fieldname','materials.rho_water','>',0);
@@ -119,17 +113,7 @@
 				md = checkfield(md,'fieldname','materials.mu_water','>',0);
 				md = checkfield(md,'fieldname','materials.rheology_B','>',0,'universal',1,'NaN',1,'Inf',1);
-				md = checkfield(md,'fieldname','materials.rheology_n','>',0,'size',[md.mesh.numberofelements 1]);
+				md = checkfield(md,'fieldname','materials.rheology_n','>',0,'universal',1,'NaN',1,'Inf',1);
 				md = checkfield(md,'fieldname','materials.rheology_law','values',{'None' 'BuddJacka' 'Cuffey' 'CuffeyTemperate' 'Paterson' 'Arrhenius' 'LliboutryDuval' 'NyeCO2' 'NyeH2O'});
 				md = checkfield(md,'fieldname','materials.effectiveconductivity_averaging','numel',[1],'values',[0 1 2]);
-			end
-
-			if ismember('GiaAnalysis',analyses),
-				md = checkfield(md,'fieldname','materials.lithosphere_shear_modulus','>',0,'numel',1);
-				md = checkfield(md,'fieldname','materials.lithosphere_density','>',0,'numel',1);
-				md = checkfield(md,'fieldname','materials.mantle_shear_modulus','>',0,'numel',1);
-				md = checkfield(md,'fieldname','materials.mantle_density','>',0,'numel',1);
-			end
-			if ismember('SealevelriseAnalysis',analyses),
-				md = checkfield(md,'fieldname','materials.earth_density','>',0,'numel',1);
 			end
 
@@ -154,8 +138,4 @@
 			fielddisplay(self,'rheology_n','Glen''s flow law exponent');
 			fielddisplay(self,'rheology_law',['law for the temperature dependance of the rheology: ''None'', ''BuddJacka'', Cuffey'', ''CuffeyTemperate'', ''Paterson'', ''Arrhenius'', ''LliboutryDuval'', ''NyeH2O'', or ''NyeCO2''']);
-			fielddisplay(self,'lithosphere_shear_modulus','Lithosphere shear modulus [Pa]');
-			fielddisplay(self,'lithosphere_density','Lithosphere density [g/cm^-3]');
-			fielddisplay(self,'mantle_shear_modulus','Mantle shear modulus [Pa]');
-			fielddisplay(self,'mantle_density','Mantle density [g/cm^-3]');
 			fielddisplay(self,'earth_density','Mantle density [kg/m^-3]');
 		end % }}}
@@ -183,8 +163,4 @@
 			WriteData(fid,prefix,'object',self,'class','materials','fieldname','rheology_n','format','DoubleMat','mattype',2);
 			WriteData(fid,prefix,'data',self.rheology_law,'name','md.materials.rheology_law','format','String');
-			WriteData(fid,prefix,'object',self,'class','materials','fieldname','lithosphere_shear_modulus','format','Double');
-			WriteData(fid,prefix,'object',self,'class','materials','fieldname','lithosphere_density','format','Double','scale',10^3);
-			WriteData(fid,prefix,'object',self,'class','materials','fieldname','mantle_shear_modulus','format','Double');
-			WriteData(fid,prefix,'object',self,'class','materials','fieldname','mantle_density','format','Double','scale',10^3);
 			WriteData(fid,prefix,'object',self,'class','materials','fieldname','earth_density','format','Double');
 		end % }}}
@@ -208,8 +184,4 @@
 			writejs1Darray(fid,[modelname '.materials.rheology_n'],self.rheology_n);
 			writejsstring(fid,[modelname '.materials.rheology_law'],self.rheology_law);
-			writejsdouble(fid,[modelname '.materials.lithosphere_shear_modulus'],self.lithosphere_shear_modulus);
-			writejsdouble(fid,[modelname '.materials.lithosphere_density'],self.lithosphere_density);
-			writejsdouble(fid,[modelname '.materials.mantle_shear_modulus'],self.mantle_shear_modulus);
-			writejsdouble(fid,[modelname '.materials.mantle_density'],self.mantle_density);
 			writejsdouble(fid,[modelname '.materials.earth_density'],self.earth_density);
 
Index: issm/trunk/src/m/classes/matice.py
===================================================================
--- issm/trunk/src/m/classes/matice.py	(revision 25994)
+++ issm/trunk/src/m/classes/matice.py	(revision 26744)
@@ -8,116 +8,105 @@
 
 class matice(object):
-    '''
-    MATICE class definition
+    """MATICE class definition
 
     Usage:
             matice = matice()
-    '''
+    """
 
-    def __init__(self): #{{{
-        self.rho_ice = 0.
-        self.rho_water = 0.
-        self.rho_freshwater = 0.
-        self.mu_water = 0.
-        self.heatcapacity = 0.
-        self.latentheat = 0.
-        self.thermalconductivity = 0.
-        self.temperateiceconductivity = 0.
+    def __init__(self):  # {{{
+        self.rho_ice = 0
+        self.rho_water = 0
+        self.rho_freshwater = 0
+        self.mu_water = 0
+        self.heatcapacity = 0
+        self.latentheat = 0
+        self.thermalconductivity = 0
+        self.temperateiceconductivity = 0
         self.effectiveconductivity_averaging = 0
-        self.meltingpoint = 0.
-        self.beta = 0.
-        self.mixed_layer_capacity = 0.
-        self.thermal_exchange_velocity = 0.
+        self.meltingpoint = 0
+        self.beta = 0
+        self.mixed_layer_capacity = 0
+        self.thermal_exchange_velocity = 0
         self.rheology_B = np.nan
         self.rheology_n = np.nan
         self.rheology_law = ''
 
-        #giaivins
-        self.lithosphere_shear_modulus = 0.
-        self.lithosphere_density = 0.
-        self.mantle_shear_modulus = 0.
-        self.mantle_density = 0.
+        # SLC
+        self.earth_density = 0
 
-        #slr
-        self.earth_density = 0
         self.setdefaultparameters()
-    #}}}
+    # }}}
 
-    def __repr__(self): #{{{
-        s = "   Materials:"
-        s = "%s\n%s" % (s, fielddisplay(self, "rho_ice", "ice density [kg/m^3]"))
-        s = "%s\n%s" % (s, fielddisplay(self, "rho_water", "water density [kg/m^3]"))
-        s = "%s\n%s" % (s, fielddisplay(self, "rho_freshwater", "fresh water density [kg/m^3]"))
-        s = "%s\n%s" % (s, fielddisplay(self, "mu_water", "water viscosity [Ns/m^2]"))
-        s = "%s\n%s" % (s, fielddisplay(self, "heatcapacity", "heat capacity [J/kg/K]"))
-        s = "%s\n%s" % (s, fielddisplay(self, "thermalconductivity", "ice thermal conductivity [W/m/K]"))
-        s = "%s\n%s" % (s, fielddisplay(self, "temperateiceconductivity", "temperate ice thermal conductivity [W/m/K]"))
-        s = "%s\n%s" % (s, fielddisplay(self, "effectiveconductivity_averaging", "computation of effectiveconductivity: (0) arithmetic mean, (1) harmonic mean, (2) geometric mean (default)"))
-        s = "%s\n%s" % (s, fielddisplay(self, "meltingpoint", "melting point of ice at 1atm in K"))
-        s = "%s\n%s" % (s, fielddisplay(self, "latentheat", "latent heat of fusion [J/m^3]"))
-        s = "%s\n%s" % (s, fielddisplay(self, "beta", "rate of change of melting point with pressure [K/Pa]"))
-        s = "%s\n%s" % (s, fielddisplay(self, "mixed_layer_capacity", "mixed layer capacity [W/kg/K]"))
-        s = "%s\n%s" % (s, fielddisplay(self, "thermal_exchange_velocity", "thermal exchange velocity [m/s]"))
-        s = "%s\n%s" % (s, fielddisplay(self, "rheology_B", "flow law parameter [Pa s^(1/n)]"))
-        s = "%s\n%s" % (s, fielddisplay(self, "rheology_n", "Glen's flow law exponent"))
-        s = "%s\n%s" % (s, fielddisplay(self, "rheology_law", "law for the temperature dependance of the rheology: 'None', 'BuddJacka', 'Cuffey', 'CuffeyTemperate', 'Paterson', 'Arrhenius', 'LliboutryDuval', 'NyeCO2', or 'NyeH2O'"))
-        s = "%s\n%s" % (s, fielddisplay(self, "lithosphere_shear_modulus", "Lithosphere shear modulus [Pa]"))
-        s = "%s\n%s" % (s, fielddisplay(self, "lithosphere_density", "Lithosphere density [g/cm^-3]"))
-        s = "%s\n%s" % (s, fielddisplay(self, "mantle_shear_modulus", "Mantle shear modulus [Pa]"))
-        s = "%s\n%s" % (s, fielddisplay(self, "mantle_density", "Mantle density [g/cm^-3]"))
-        s = "%s\n%s" % (s, fielddisplay(self, "earth_density", "Mantle density [kg/m^-3]"))
+    def __repr__(self):  # {{{
+        s = '   Materials:\n'
+        s += '{}\n'.format(fielddisplay(self, 'rho_ice', 'ice density [kg/m^3]'))
+        s += '{}\n'.format(fielddisplay(self, 'rho_water', 'water density [kg/m^3]'))
+        s += '{}\n'.format(fielddisplay(self, 'rho_freshwater', 'fresh water density [kg/m^3]'))
+        s += '{}\n'.format(fielddisplay(self, 'mu_water', 'water viscosity [Ns/m^2]'))
+        s += '{}\n'.format(fielddisplay(self, 'heatcapacity', 'heat capacity [J/kg/K]'))
+        s += '{}\n'.format(fielddisplay(self, 'thermalconductivity', 'ice thermal conductivity [W/m/K]'))
+        s += '{}\n'.format(fielddisplay(self, 'temperateiceconductivity', 'temperate ice thermal conductivity [W/m/K]'))
+        s += '{}\n'.format(fielddisplay(self, 'effectiveconductivity_averaging', 'computation of effectiveconductivity: (0) arithmetic mean, (1) harmonic mean, (2) geometric mean (default)'))
+        s += '{}\n'.format(fielddisplay(self, 'meltingpoint', 'melting point of ice at 1atm in K'))
+        s += '{}\n'.format(fielddisplay(self, 'latentheat', 'latent heat of fusion [J/m^3]'))
+        s += '{}\n'.format(fielddisplay(self, 'beta', 'rate of change of melting point with pressure [K/Pa]'))
+        s += '{}\n'.format(fielddisplay(self, 'mixed_layer_capacity', 'mixed layer capacity [W/kg/K]'))
+        s += '{}\n'.format(fielddisplay(self, 'thermal_exchange_velocity', 'thermal exchange velocity [m/s]'))
+        s += '{}\n'.format(fielddisplay(self, 'rheology_B', 'flow law parameter [Pa s^(1/n)]'))
+        s += '{}\n'.format(fielddisplay(self, 'rheology_n', 'Glen\'s flow law exponent'))
+        s += '{}\n'.format(fielddisplay(self, 'rheology_law', 'law for the temperature dependance of the rheology: \'None\', \'BuddJacka\', \'Cuffey\', \'CuffeyTemperate\', \'Paterson\', \'Arrhenius\', \'LliboutryDuval\', \'NyeCO2\', or \'NyeH2O\''))
+        s += '{}\n'.format(fielddisplay(self, 'earth_density', 'Mantle density [kg/m^-3]'))
+        return s
+    # }}}
 
-        return s
-    #}}}
-
-    def extrude(self, md): #{{{
+    def extrude(self, md):  # {{{
         self.rheology_B = project3d(md, 'vector', self.rheology_B, 'type', 'node')
         self.rheology_n = project3d(md, 'vector', self.rheology_n, 'type', 'element')
         return self
-    #}}}
+    # }}}
 
-    def setdefaultparameters(self): #{{{
-        #ice density (kg/m^3)
-        self.rho_ice = 917.
-        #ocean water density (kg/m^3)
-        self.rho_water = 1023.
-        #fresh water density (kg/m^3)
-        self.rho_freshwater = 1000.
-        #water viscosity (N.s/m^2)
+    def setdefaultparameters(self):  # {{{
+        # Ice density (kg/m^3)
+        self.rho_ice = 917.0
+        # Ocean water density (kg/m^3)
+        self.rho_water = 1023.0
+        # Fresh water density (kg/m^3)
+        self.rho_freshwater = 1000.0
+        # Water viscosity (N.s/m^2)
         self.mu_water = 0.001787
-        #ice heat capacity cp (J/kg/K)
-        self.heatcapacity = 2093.
-        #ice latent heat of fusion L (J/kg)
-        self.latentheat = 3.34e5
-        #ice thermal conductivity (W/m/K)
+        # Ice heat capacity cp (J/kg/K)
+        self.heatcapacity = 2093.0
+        # Ice latent heat of fusion L (J/kg)
+        self.latentheat = 3.34 * pow(10, 5)
+        # Ice thermal conductivity (W/m/K)
         self.thermalconductivity = 2.4
-        #temperate ice thermal conductivity (W/m/K)
+        # Temperate ice thermal conductivity (W/m/K)
         self.temperateiceconductivity = 0.24
-        #computation of effective conductivity
+        # Computation of effective conductivity
         self.effectiveconductivity_averaging = 1
-        #the melting point of ice at 1 atmosphere of pressure in K
+        # The melting point of ice at 1 atmosphere of pressure in K
         self.meltingpoint = 273.15
-        #rate of change of melting point with pressure (K/Pa)
-        self.beta = 9.8e-8
-        #mixed layer (ice-water interface) heat capacity (J/kg/K)
-        self.mixed_layer_capacity = 3974.
-        #thermal exchange velocity (ice-water interface) (m/s)
-        self.thermal_exchange_velocity = 1.00e-4
-        #Rheology law: what is the temperature dependence of B with T
-        #available: none, paterson and arrhenius
+        # Rate of change of melting point with pressure (K/Pa)
+        self.beta = 9.8 * pow(10, -8)
+        # Mixed layer (ice-water interface) heat capacity (J/kg/K)
+        self.mixed_layer_capacity = 3974.0
+        # Thermal exchange velocity (ice-water interface) (m/s)
+        self.thermal_exchange_velocity = 1.00 * pow(10, -4)
+        # Rheology law: what is the temperature dependence of B with T
+        # available: none, paterson and arrhenius
         self.rheology_law = 'Paterson'
 
-        # GIA:
-        self.lithosphere_shear_modulus = 6.7e10 # (Pa)
-        self.lithosphere_density = 3.32  # (g/cm^-3)
-        self.mantle_shear_modulus = 1.45e11  # (Pa)
-        self.mantle_density = 3.34  # (g/cm^-3)
+        # Rheology for ice
+        self.rheology_B = 2.1 * 1e8
+        self.rheology_n = 3
 
         # SLR
         self.earth_density = 5512  # average density of the Earth, (kg/m^3)
-    #}}}
+    # }}}
 
-    def checkconsistency(self, md, solution, analyses): #{{{
-        if solution != 'SealevelriseSolution':
+    def checkconsistency(self, md, solution, analyses):  # {{{
+        if solution == 'TransientSolution' and md.transient.isslc:
+            md = checkfield(md, 'fieldname', 'materials.earth_density', '>', 0, 'numel', [1])
+        else:
             md = checkfield(md, 'fieldname', 'materials.rho_ice', '>', 0)
             md = checkfield(md, 'fieldname', 'materials.rho_water', '>', 0)
@@ -125,21 +114,12 @@
             md = checkfield(md, 'fieldname', 'materials.mu_water', '>', 0)
             md = checkfield(md, 'fieldname', 'materials.rheology_B', '>', 0, 'universal', 1, 'NaN', 1, 'Inf', 1)
-            md = checkfield(md, 'fieldname', 'materials.rheology_n', '>', 0, 'size', [md.mesh.numberofelements])
+            md = checkfield(md, 'fieldname', 'materials.rheology_n', '>', 0, 'universal',1, 'NaN', 1, 'Inf', 1)
             md = checkfield(md, 'fieldname', 'materials.rheology_law', 'values', ['None', 'BuddJacka', 'Cuffey', 'CuffeyTemperate', 'Paterson', 'Arrhenius', 'LliboutryDuval', 'NyeCO2', 'NyeH2O'])
             md = checkfield(md, 'fieldname', 'materials.effectiveconductivity_averaging', 'numel', [1], 'values', [0, 1, 2])
 
-        if 'GiaAnalysis' in analyses:
-            md = checkfield(md, 'fieldname', 'materials.lithosphere_shear_modulus', '>', 0, 'numel', [1])
-            md = checkfield(md, 'fieldname', 'materials.lithosphere_density', '>', 0, 'numel', [1])
-            md = checkfield(md, 'fieldname', 'materials.mantle_shear_modulus', '>', 0, 'numel', [1])
-            md = checkfield(md, 'fieldname', 'materials.mantle_density', '>', 0, 'numel', [1])
+        return md
+    # }}}
 
-        if 'SealevelriseAnalysis' in analyses:
-            md = checkfield(md, 'fieldname', 'materials.earth_density', '>', 0, 'numel', [1])
-
-        return md
-    #}}}
-
-    def marshall(self, prefix, md, fid): #{{{
+    def marshall(self, prefix, md, fid):  # {{{
         WriteData(fid, prefix, 'name', 'md.materials.type', 'data', 3, 'format', 'Integer')
         WriteData(fid, prefix, 'object', self, 'class', 'materials', 'fieldname', 'rho_ice', 'format', 'Double')
@@ -156,11 +136,14 @@
         WriteData(fid, prefix, 'object', self, 'class', 'materials', 'fieldname', 'mixed_layer_capacity', 'format', 'Double')
         WriteData(fid, prefix, 'object', self, 'class', 'materials', 'fieldname', 'thermal_exchange_velocity', 'format', 'Double')
-        WriteData(fid, prefix, 'object', self, 'class', 'materials', 'fieldname', 'rheology_B', 'format', 'DoubleMat', 'mattype', 1, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', md.constants.yts)
+        # NOTE: We first have to check if we have a NumPy array here
+        if np.size(self.rheology_B)==1 or (((np.shape(self.rheology_B)[0] == md.mesh.numberofvertices) or (np.shape(self.rheology_B)[0] == md.mesh.numberofvertices + 1)) or ((len(np.shape(self.rheology_B)) == 2) and (np.shape(self.rheology_B)[0] == md.mesh.numberofelements) and (np.shape(self.rheology_B)[1] > 1))):
+            mattype = 1
+            tsl = md.mesh.numberofvertices
+        else:
+            mattype = 2
+            tsl = md.mesh.numberofelements
+        WriteData(fid, prefix, 'object', self, 'class', 'materials', 'fieldname', 'rheology_B', 'format', 'DoubleMat', 'mattype', mattype, 'timeserieslength', tsl + 1, 'yts', md.constants.yts)
         WriteData(fid, prefix, 'object', self, 'class', 'materials', 'fieldname', 'rheology_n', 'format', 'DoubleMat', 'mattype', 2)
         WriteData(fid, prefix, 'data', self.rheology_law, 'name', 'md.materials.rheology_law', 'format', 'String')
-        WriteData(fid, prefix, 'object', self, 'class', 'materials', 'fieldname', 'lithosphere_shear_modulus', 'format', 'Double')
-        WriteData(fid, prefix, 'object', self, 'class', 'materials', 'fieldname', 'lithosphere_density', 'format', 'Double', 'scale', 10.**3.)
-        WriteData(fid, prefix, 'object', self, 'class', 'materials', 'fieldname', 'mantle_shear_modulus', 'format', 'Double')
-        WriteData(fid, prefix, 'object', self, 'class', 'materials', 'fieldname', 'mantle_density', 'format', 'Double', 'scale', 10.**3.)
         WriteData(fid, prefix, 'object', self, 'class', 'materials', 'fieldname', 'earth_density', 'format', 'Double')
-    #}}}
+    # }}}
Index: issm/trunk/src/m/classes/mesh3dprisms.js
===================================================================
--- issm/trunk/src/m/classes/mesh3dprisms.js	(revision 25994)
+++ issm/trunk/src/m/classes/mesh3dprisms.js	(revision 26744)
@@ -23,5 +23,5 @@
 
             if(ArrayAnyEqual(ArrayIsMember(NewArrayFillIncrement(md.mesh.numberofvertices,1,1),ArraySort(ArrayUnique(MatrixToList(md.mesh.elements)))),0)){
-				//md = checkmessage(md,'orphan nodes have been found. Check the mesh outline'); @TODO
+				//checkmessage(md,'orphan nodes have been found. Check the mesh outline'); @TODO
                 md.checkmessage('orphan nodes have been found. Check the mesh outline');
 			}
@@ -127,5 +127,6 @@
         } //}}}
 
-        //properties (SetAccess=public) 
+	//properties 
+	// {{{
         this.x                           = NaN;
         this.y                           = NaN;
@@ -139,5 +140,5 @@
         this.long                        = NaN;
         this.epsg                        = 0;
-		  this.scale_factor                = NaN;
+		this.scale_factor                = NaN;
 
         this.vertexonbase                = NaN;
@@ -161,3 +162,4 @@
         this.extractedvertices           = NaN;
         this.extractedelements           = NaN;
+	//}}}
 }
Index: issm/trunk/src/m/classes/mesh3dsurface.js
===================================================================
--- issm/trunk/src/m/classes/mesh3dsurface.js	(revision 25994)
+++ issm/trunk/src/m/classes/mesh3dsurface.js	(revision 26744)
@@ -87,4 +87,5 @@
 			WriteData(fid,prefix,'object',this,'fieldname','long','format','DoubleMat','mattype',1);
 			WriteData(fid,prefix,'object',this,'fieldname','r','format','DoubleMat','mattype',1);
+			//WriteData(fid,prefix,'object',this,'fieldname','z','format','DoubleMat','mattype',1);
 			WriteData(fid,prefix,'object',this,'fieldname','elements','format','DoubleMat','mattype',2);
 			WriteData(fid,prefix,'object',this,'fieldname','numberofelements','format','Integer');
@@ -92,5 +93,5 @@
 			WriteData(fid,prefix,'object',this,'fieldname','average_vertex_connectivity','format','Integer');
 			WriteData(fid,prefix,'object',this,'fieldname','vertexonboundary','format','DoubleMat','mattype',1);
-			WriteData(fid,prefix,'object',this,'fieldname','segments','format','DoubleMat','mattype',3);
+			//WriteData(fid,prefix,'object',this,'fieldname','segments','format','DoubleMat','mattype',3);
 		}//}}}
 		this.fix=function() { //{{{
Index: issm/trunk/src/m/classes/mmeadditionalsolidearthsolution.m
===================================================================
--- issm/trunk/src/m/classes/mmeadditionalsolidearthsolution.m	(revision 26744)
+++ issm/trunk/src/m/classes/mmeadditionalsolidearthsolution.m	(revision 26744)
@@ -0,0 +1,104 @@
+%MMEADDITIONALSOLIDEARTHSOLUTION class definition
+%
+%   Usage:
+%      addsol=mmeadditionalsolidearthsolution(); where the additional solid earth solutions %                               are based on a multi-model ensemble (ex: Caron et al 2017 statistics) 
+
+classdef mmeadditionalsolidearthsolution < additionalsolidearthsolution 
+	properties (SetAccess=public) 
+		modelid; %index into the multi-model ensemble, each ensemble variable being defined 
+	         %in the father class.
+	end
+	methods
+		function self = mmeadditionalsolidearthsolution(varargin) % {{{
+			switch nargin
+				case 0
+					self=setdefaultparameters(self);
+				otherwise
+					error('constructor not supported');
+			end
+		end % }}}
+		function self = setdefaultparameters(self) % {{{
+			self.setdefaultparameters@additionalsolidearthsolution();
+			self.modelid=0;
+		end % }}}
+		function md = checkconsistency(self,md,solution,analyses) % {{{
+
+			if ~ismember('SealevelchangeAnalysis',analyses) | (strcmp(solution,'TransientSolution') & md.solidearth.settings.isgrd==0), 
+				error('mmeadditionalsolidearthsolution checkconsistency error message: need to run GRD solution if you are supplying a GRD additional pattern solution');
+			end
+
+			seast=length(self.displacementeast);
+			snorth=length(self.displacementnorth);
+			sup=length(self.displacementup);
+			sgeoid=length(self.geoid);
+
+			if (seast-snorth)~=0,
+				error('mmeadditionalsolidearthsolution checkconsistency error message: displacementeast and displacementnorth should be the same size');
+			end
+
+			if (seast-sup)~=0,
+				error('mmeadditionalsolidearthsolution checkconsistency error message: displacementeast and displacementup should be the same size');
+			end
+
+			if (seast-sgeoid)~=0,
+				error('mmeadditionalsolidearthsolution checkconsistency error message: displacementeast and geoid should be the same size');
+			end
+			
+			md = checkfield(md,'field',self.modelid,'NaN',1,'Inf',1,'>=',1,'<=',length(self.displacementeast));
+
+			for i=1:seast,
+				md = checkfield(md,'field',self.displacementeast{i},'NaN',1,'Inf',1,'timeseries',1);
+				md = checkfield(md,'field',self.displacementup{i},'NaN',1,'Inf',1,'timeseries',1);
+				md = checkfield(md,'field',self.displacementnorth{i},'NaN',1,'Inf',1,'timeseries',1);
+				md = checkfield(md,'field',self.geoid{i},'NaN',1,'Inf',1,'timeseries',1);
+			end
+
+
+		end % }}}
+		function disp(self) % {{{
+			disp(sprintf('   external: mmeadditionalsolidearth solution:'));
+			self.disp@solidearthsolution();
+			fielddisplay(self,'modelid','index into the multi-model ensemble, determines which field will be used.');
+		end % }}}
+		function marshall(self,prefix,md,fid) % {{{
+			WriteData(fid,prefix,'data',3,'name','md.solidearth.external.nature','format','Integer'); %code 3 for mmeadditionalsolidearthsolution class
+
+			nummodels=length(self.displacementeast);
+			WriteData(fid,prefix,'name','md.solidearth.external.nummodels','data',nummodels,'format','Integer');
+			WriteData(fid,prefix,'object',self,'fieldname','modelid','format','Double');
+
+			%transform our cell array of time series into cell array of time series of rates 
+			for i=1:nummodels,
+				displacementeast=self.displacementeast{i}; 
+				displacementnorth=self.displacementnorth{i}; 
+				displacementup=self.displacementup{i}; 
+				geoid=self.geoid{i}; 
+
+				time=displacementeast(end,:);
+				dt=diff(time,1,2);
+				
+				displacementeast_rate=diff(displacementeast(1:end-1,:),1,2)./dt;
+				displacementnorth_rate=diff(displacementnorth(1:end-1,:),1,2)./dt;
+				displacementup_rate=diff(displacementup(1:end-1,:),1,2)./dt;
+				geoid_rate=diff(geoid(1:end-1,:),1,2)./dt;
+
+				self.displacementeast{i}=displacementeast_rate; 
+				self.displacementnorth{i}=displacementnorth_rate; 
+				self.displacementup{i}=displacementup_rate; 
+				self.geoid{i}=geoid_rate; 
+			end
+			
+			WriteData(fid,prefix,'object',self,'fieldname','displacementeast','format','MatArray','timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts,'scale',1/yts);
+			WriteData(fid,prefix,'object',self,'fieldname','displacementup','format','MatArray','timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts,'scale',1/yts);
+			WriteData(fid,prefix,'object',self,'fieldname','displacementnorth','format','MatArray','timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts,'scale',1/yts);
+			WriteData(fid,prefix,'object',self,'fieldname','geoid','format','MatArray','timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts,'scale',1/yts);
+
+		end % }}}
+
+		function savemodeljs(self,fid,modelname) % {{{
+			error('mmeadditionalsolidearthsolution error message: not implemented yet');
+		end % }}}
+		function self = extrude(self,md) % {{{
+		end % }}}
+	end
+end
